searchNodes=[{"doc":"A DSL for easily building dynamic, reusable components for your frontend framework in Elixir. defcontenttag :card, tag: :div, class: &quot;card&quot; card do &quot;Content!&quot; end #=&gt; &lt;div class=&quot;card&quot;&gt;Content!&lt;/div&gt; defcontenttag :alert, tag: :div, class: &quot;alert&quot;, variants: [:primary, :success] alert :primary, &quot;Alert!&quot; #=&gt; &lt;div class=&quot;alert alert-primary&quot;&gt;Alert!&lt;/div&gt; alert :primary, &quot;Alert!&quot;, class: &quot;extra&quot; #=&gt; &lt;div class=&quot;alert alert-primary extra&quot;&gt;Alert!&lt;/div&gt; alert :success, &quot;Alert!&quot; #=&gt; &lt;div class=&quot;alert alert-success&quot;&gt;Alert!&lt;/div&gt; Generated function clauses accept a block and a list of opts. alert :primary, class: &quot;extra&quot; do &quot;Alert!&quot; end #=&gt; &lt;div class=&quot;alert alert-primary extra&quot;&gt;Alert!&lt;/div&gt; Usage The lib defines two macros: deftag and defcontenttag. The deftag macro defines void components, those that do not accept their own content, like hr, while the defcontenttag macro defines components that accept their own content, like div. Function Delegation The :tag option accepts an atom and an anonymous function, which allows you to generate components that defer execution to another function. This is useful if you want to use Phoenix.HTML.Link.link/2, for example. defcontenttag :list_group_item, tag: &amp;Phoenix.HTML.Link.link/2, class: &quot;list-group-item&quot; list_group_item &quot;Action&quot;, to: &quot;#&quot; #=&gt; &lt;a href=&quot;#&quot; class: &quot;list-group-item&quot;&gt;Action&lt;/a&gt; CSS Class The :class option is the base class of the component and is used to build variant classes in the form class=&quot;{class class-variant}&quot;. Variants The :variants option adds a modifier class to the component and generates component/3 clauses for each variant, where the variant is the first argument. defcontenttag :alert, tag: :div, class: &quot;alert&quot;, variants: [:success] alert :success, class: &quot;extra&quot; do &quot;Alert!&quot; end #=&gt; &lt;div class=&quot;alert alert-success extra&quot;&gt;Alert!&lt;/div&gt; Some components have multiple variants. You can use component/2 and pass a list to the :variants option. list_group variants: [:flush, :horizontal], class: &quot;extra&quot; do &quot;...&quot; end #=&gt; &lt;div class=&quot;list-group list-group-flush list-group-horizontal &quot;&gt;...&lt;/div&gt; Variant Class Some components have variants that do not inherit the component&#39;s base class, or have a custom class. For example, the dropup and dropleft variants of Bootstrap&#39;s dropdowns. Set variant_class_prefix: false to define a variant without a class prefix. You can also provide your own custom prefix. defcontenttag :dropdown, tag: :div, class: &quot;dropdown&quot;, variants: [:dropup, :dropleft], variant_class_prefix: false dropdown :dropleft do ... end #=&gt; &lt;div class=&quot;dropdown dropleft&quot;&gt;...&lt;/div&gt; Appending and Prepending Content Use :append and/or :prepend to add additional content your component. For example, a Bootstrap alert that has a close button. defcontenttag :close, tag: :button, wrap_content: :span, class: &quot;close&quot;, data: [dismiss: &quot;alert&quot;], aria: [label: &quot;Close&quot;] defcontenttag :alert, tag: :div, class: &quot;alert&quot;, prepend: close(&quot;&amp;times;&quot;), variants: [:primary] alert :primary do &quot;Content&quot; end &lt;div class=&quot;alert alert-primary&quot;&gt; &lt;button aria-label=&quot;Close&quot; class=&quot;close&quot; data-dismiss=&quot;alert&quot;&gt; &lt;span&gt;&amp;times;&lt;/span&gt; &lt;/button&gt; Content &lt;/div&gt; Both options accept an atom, or a tuple in one the forms {:safe, iodata}, {:tag, opts}, {:tag, &quot;content&quot;}, and {:tag, &quot;content&quot;, opts}. Nesting Components The :parent option is useful for nesting a component in an additional tag. You can pass an atom, or a tuple with either a function or an atom, and a list of parent options. For example, breadcrumbs in Bootstrap are built with an ol tag wrapped in a nav tag. &lt;nav role=&quot;nav&quot;&gt; &lt;ol class=&quot;breadcrumbs&quot;&gt; &lt;li class=&quot;breadcrumbs-item&quot;&gt;...&lt;/li&gt; &lt;/ol&gt; &lt;/nav&gt; You can use the parent: :nav or parent: {:nav, [role: &quot;nav&quot;]} to address this case. defcontenttag :breadcrumbs, tag: :ol, ..., parent: :nav defcontenttag :breadcrumbs, tag: :ol, ..., parent: {:nav, [role: &quot;nav&quot;]} You can also pass an anonymouse function to the parent option. defcontenttag :breadcrumbs, tag: :ol, ..., parent: &amp;fun/1 Wrapping Content The :wrap_content option works exactly like the :parent option except that it wraps the content of the component rather than the component itself. For example, a Bootstrap button whose text is wrapped in a span. defcontenttag :button, tag: :button, ..., wrap_content: :span Default HTML Options You can pass a list of HTML options to :html_opts, which gets forwarded to the underlying HTML. Any default options can be overriden during function calls. Options :class - the component&#39;s class name. This option is required. :html_opts - a list of opts to forward onto the HTML. :parent - wraps the component in the given tag. Accepts an atom, a anonymous function, or a tuple where the first element is the parent tag and the second is a list of parent options. For example, {:div, [class: &quot;something&quot;]}. :prepend - prepends the given tag to the component&#39;s content. Accepts a tuple in the following format: {:safe, iodata}, {:tag, opts}, {:tag, &quot;content&quot;}, or {:tag, &quot;content&quot;, opts}. For example, {:hr, [class: &quot;divider&quot;]} or {:button, &quot;Dropdown&quot;, class: &quot;extra&quot;}. :append - appends the given content to the component. See the :prepend option for usage. :wrap_content - wraps the inner content of the component in the given tag. See the :parent option for usage. :variants - a list of component variants. Each variant generates a component/3 (component/2 for deftag) function clause where an atom variant name is the first argument. :variant_class_prefix - the class prefix to use when composing variants. Defaults to the class option. Use false for no prefix.","ref":"ExComponent.html","title":"ExComponent","type":"module"},{"doc":"","ref":"ExComponent.html#defcontenttag/2","title":"ExComponent.defcontenttag/2","type":"macro"},{"doc":"","ref":"ExComponent.html#deftag/2","title":"ExComponent.deftag/2","type":"macro"},{"doc":"Contains configuration options. overridable_opts - a list of default component options that can be overridden during function calls.","ref":"ExComponent.Config.html","title":"ExComponent.Config","type":"module"},{"doc":"","ref":"ExComponent.Config.html#get_config/1","title":"ExComponent.Config.get_config/1","type":"function"}]